//////////////////////////////////////////////////////////////////////////////////
// our javascript namespace object
/////////////////////////////////////////////////////////////////////////////////
if ("undefined" == typeof(DisplayQuota)) {  
  var DisplayQuota = {  
     alertDialog: null,
     lap: 900000,      // 15 minutes between notifications
     firstwarn: 1,
     currentServerName: null,
     debug: 0,   
     
      // checkQuota 
      checkQuota: function(item,event) {
        if(this.debug == 2) dump("DQ: In checkQuota");
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { if(this.debug) dump("DQ: Erreur de chargement: " + ex + "\n"); }

	if(this.debug == 2) dump("DQ: etape 1\n");

        try {
          var selectedURI; //= this._getSelectedFolderURI();
          if(typeof GetSelectedFolderURI != 'function') {
            var selectedFolders = gFolderTreeView.getSelectedFolders();
            selectedURI = selectedFolders[0].URI
          } else {
            selectedURI = GetSelectedFolderURI(); 
          }
	} catch (ex) {
	  if(this.debug) dump("DQ: erreur de GetSelectedFolderURI " + ex + "\n");
	}
	if(this.debug == 2) dump("DQ: etape 1.1" + selectedURI + "\n");	

	try {
	  if(!RDF) 
	    var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	  var folderResource = RDF.GetResource(selectedURI);
	} catch (ex) {
        	if(this.debug) dump("DQ: erreur de RDF.GetResource " + ex + "\n");
	}
	if(this.debug == 2) dump("DQ: etape 1.2\n");		
	
	if (folderResource) mMsgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);

	if(this.debug == 2) dump("DQ: etape 2\n");

        var msgFolder = GetMsgFolderFromUri(selectedURI, true);
	var serverType = msgFolder.server.type;
	if ( msgFolder.server.prettyName != this.currentServerName ) {
		this.firstwarn = 1;
		this.currentServerName = msgFolder.server.prettyName;
	}

        if(this.debug == 2) dump("DQ: "+ this.currentServerName + "  " + serverType + " : " + event + "\n" );	

	if(serverType == "imap") {
		var imapFolder = mMsgFolder.QueryInterface(Components.interfaces.nsIMsgImapMailFolder);
    		if (imapFolder) {
			imapFolder.fillInFolderProps(DisplayQuotaFolderPropsSink);
		}
	} else { 
		var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
		var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
		var quotaLabelPC = document.getElementById('DisplayQuota-percent');

		var notimap = DisplayQuotaStrBundle.GetStringFromName("notimap");
      		quotaProgress.setAttribute("tooltiptext",notimap);
		quotaLabelPC.setAttribute("value","");
		quotaProgress.setAttribute("value",0);		
	}
	if(this.debug == 2) dump("DQ: Out checkQuota");
      },

      // addToSession
      addToSession: function() {
        if(this.debug == 2) dump("DQ: In DisplayQuotaAddToSession\n");
	var mailSessionContractID = "@mozilla.org/messenger/services/session;1";
	try {
          var mailSession = Components.classes[mailSessionContractID].getService(Components.interfaces.nsIMsgMailSession);
          var nsIFolderListener = Components.interfaces.nsIFolderListener;
          var notifyFlags = nsIFolderListener.event;
          mailSession.AddFolderListener(DisplayQuotaFolderListener, notifyFlags);
        } catch (ex) { if(this.debug) dump("DQ: Error adding to session\n"); }
        if(this.debug == 2) dump("DQ: Out DisplayQuotaAddToSession\n");
      },

      // init
      init: function() {
        if(this.debug == 2) dump("DQ: In DisplayQuotaInit\n");
	var pastDate = new Date("February 5, 2001 23:15:00");
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING) {
		DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",pastDate);
	}
	/*if (DisplayQuotaPrefs.getPrefType("extension.displayquota.debug") == DisplayQuotaPrefs.PREF_BOOL) {
	  debug = DisplayQuotaPrefs.getIntPref("extension.displayquota.debug");
	}*/
	if(this.debug == 2) dump("DQ: Out DisplayQuotaInit\n");
      },

    }
};

//////////////////////////////////////////////////////////////////////////////////
// container for all the folder properties
/////////////////////////////////////////////////////////////////////////////////
var DisplayQuotaFolderPropsSink = {
    setFolderType: function(folderTypeString) {},
    setFolderTypeDescription: function(folderDescription) {},
    setFolderPermissions: function(folderPermissions) {},
    serverDoesntSupportACL : function() {},
    setQuotaStatus : function() {},

    showQuotaData : function(showData) {
    
        if(DisplayQuota.debug == 2) dump("DQ: In ShowQuotaData\n");
      
	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
	var quotaLabelPC = document.getElementById('DisplayQuota-percent');

	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	
      	if(showData == false) {
		var noquota = DisplayQuotaStrBundle.GetStringFromName("noquota");
      		quotaProgress.setAttribute("tooltiptext",noquota);
		quotaLabelPC.setAttribute("value","");
		quotaProgress.setAttribute("value",0);	
      	}
      	
      	if(this.debug == 2) dump("DQ: Out ShowQuotaData\n"); 
    },

    setQuotaData : function(root, usedKB, maxKB)
    {
    
        if(this.debug == 2) dump("DQ: In SetQuotaData\n");
    
      	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
      	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
        var quotaLabelText = document.getElementById('DisplayQuota-text');
	var quotaLabelPC = document.getElementById('DisplayQuota-percent');
	var quotaIcon = document.getElementById('DisplayQuota-icon');
	
	// disable thunderbird's default quota progressbar
	var quotaPanel = document.getElementById('quotaPanel');
	if(quotaPanel && quotaPanel.getAttribute("hidden") != "true") {
	  if(this.debug) dump("DQ: quotaPanel is there, hidding it\n");
	  quotaPanel.setAttribute("hidden","true");
        }

	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { if(this.debug) dump("DQ: erreur bundle: " + ex + "\n"); }

	var whenusenotif = 1;
	var donotbug = false;
	var warnpercent = 90;
	var lastwarn = "0";
	var lastpercentage = 0;

	/*if (DisplayQuotaPrefs.getPrefType("extension.displayquota.debug") == DisplayQuotaPrefs.PREF_BOOL) {
	  this.debug = DisplayQuotaPrefs.getIntPref("extension.displayquota.debug");
	}*/

	//if(this.debug == 2) dump("DQ: "+this.currentServerName + ": in setQuota \n");

	// get the values from the perferences
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.whenusenotif") == DisplayQuotaPrefs.PREF_INT) {
		whenusenotif = DisplayQuotaPrefs.getIntPref("extension.displayquota.whenusenotif");
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.warnpercent") == DisplayQuotaPrefs.PREF_INT){
		warnpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.warnpercent");	
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING){
		var tmpDate = new Date(DisplayQuotaPrefs.getCharPref("extension.displayquota.lastwarn"));
		lastwarn = tmpDate.getTime();
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastpercentage") == DisplayQuotaPrefs.PREF_INT){
		lastpercentage = DisplayQuotaPrefs.getIntPref("extension.displayquota.lastpercentage");	
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.progressbarwidth") == DisplayQuotaPrefs.PREF_INT){
                quotaProgressWidth=DisplayQuotaPrefs.getIntPref("extension.displayquota.progressbarwidth");
		quotaProgress.setAttribute("width",quotaProgressWidth);
        }
        
        // let's calculate our values and units
	var percentage = (maxKB != 0) ? Math.round(usedKB / maxKB * 100) : 0;

	var unitMax = DisplayQuotaStrBundle.GetStringFromName("kilobyte");
	var unitUsed = DisplayQuotaStrBundle.GetStringFromName("kilobyte");

      	var niceUsed = usedKB;
      	var niceMax = maxKB / 1024;
 
      	if(usedKB >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("megabyte");
	 	niceUsed =  usedKB / 1024;	
      	}
      	if(niceUsed >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
		niceUsed =  niceUsed / 1024;	
      	}
      
	if(niceMax >= 1024) {
		niceMax = niceMax / 1024;
		unitMax = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
      	} else {
      		unitMax = DisplayQuotaStrBundle.GetStringFromName("megabyte");
      	}
      	
      	if(this.debug) 
      	  dump("DQ: "+this.currentServerName+" [whenusenotif: "+whenusenotif+"] [percentage: "+ percentage +"] [warnpercent: "+ warnpercent +"] [usedKB: "+ usedKB +"] [niceUsed: "+ niceMax +"] [firstwarn: "+ this.firstwarn +"]\n");
      	
      	// update the progress bar
	quotaProgress.setAttribute("value",percentage);
      	quotaLabelPC.setAttribute("value",percentage+"%");
	
	var usage = DisplayQuotaStrBundle.GetStringFromName("usage");
	var of = DisplayQuotaStrBundle.GetStringFromName("of");

	var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);

  	quotaProgress.setAttribute("tooltiptext",usage  + ": " + niceUsed.toFixed(2) + " " + unitUsed  + " " + of + " " +  niceMax.toFixed(2) + " " + unitMax + " (" + percentage +"%)");
      	if (percentage < 50) quotaLabelPC.setAttribute("status","normal");
      	if (percentage >= 50) quotaLabelPC.setAttribute("status","middle");
      	if (percentage >= warnpercent) quotaLabelPC.setAttribute("status","warning");
	if (percentage >= 90) quotaLabelPC.setAttribute("status","alert");
      	if (percentage >= 100) {
		quotaLabelPC.setAttribute("status","over");
		quotaIcon.setAttribute("hidden","false");
		quotaIcon.setAttribute("src","chrome://displayquota/skin/petit-emblem-unreadable.png");
      	}
      	// check if we need to show the notification
	if (percentage >= warnpercent) {


		var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
		var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
		var overalert= DisplayQuotaStrBundle.GetStringFromName("overalert");
		var overaler2= DisplayQuotaStrBundle.GetStringFromName("overalert2");

		quotaIcon.setAttribute("hidden","false");
		
		if (this.alertDialog) {
			this.alertDialog.close();
			this.alertDialog = null;
		}

		var currentDate = new Date();
		var currentTime = currentDate.getTime();
		var elapsed = currentTime - lastwarn;

                if(this.debug) dump("DQ: [elapsed: " + elapsed + "] [lap: "+this.lap+"]\n");

		if (elapsed >= this.lap || this.firstwarn==1) {
			DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",currentDate);
			if(this.debug) dump("DQ: " + this.currentServerName + " percentage >= warnpercent: notifying && elapsed >= lap && firstwarn == 1\n");
			if(percentage >= 100) { 
				//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotaalert");
				var notificationtitle = this.currentServerName;
				var notificationsg = overalert+" "+overalert2;
				// show notification unless setting says "never"
				if(whenusenotif<3) alertsService.showAlertNotification("chrome://displayquota/skin/emblem-unreadable.png",notificationtitle,notificationmsg,false, "", null);	
			}
			else {
				//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotawarning");
				var notificationtitle = this.currentServerName;
				var notificationmsg = warn1 + " " + percentage + "% "+ warn2;
				// show notification unless setting says "never"
				alertsService.showAlertNotification("chrome://displayquota/skin/emblem-important.png",notificationtitle,notificationmsg,false, "", null);		
				quotaIcon.setAttribute("src","chrome://displayquota/skin/petit-emblem-important.png");
			}
			this.firstwarn=0;
		}
 	} else {
		var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
		var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
		
		if (this.firstwarn==1) {
			var currentDate = new Date();
			DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",currentDate);
			//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotainfo");
			var notificationtitle = this.currentServerName;
			var notificationmsg = warn1 + " " + percentage + "% "+ warn2;
			if(whenusenotif==1) {
			  if(this.debug) dump("DQ: [whenusenotif: 1] always show notification\n");
			  alertsService.showAlertNotification("chrome://displayquota/skin/quota-ok.png",notificationtitle,notificationmsg,false, "", null);		
                        }
		}
		this.firstwarn=0;
	}

	if (percentage < warnpercent) quotaIcon.setAttribute("hidden","true");

	if(this.debug == 2) dump("DQ: Out SetQuotaData\n");

	}
};

//////////////////////////////////////////////////////////////////////////////////
// the FolderListener Object
/////////////////////////////////////////////////////////////////////////////////
var DisplayQuotaFolderListener = {
  OnItemAdded: function(parent, item, viewString) {},
  OnItemRemoved: function(parent, item, viewString) {},
  OnItemPropertyChanged: function(parent, item, viewString) {},
  OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue) {},
  OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
  OnItemEvent: DisplayQuota.checkQuota,
  OnDeleteOrMoveMessagesCompleted: function( aFolder) {}
}

// init...
if(DisplayQuota.debug) dump("DQ sez Hello\n");
DisplayQuota.init();
DisplayQuota.addToSession();
